library nueli.core.bucket;

import 'dart:ui';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'util.dart' show AdvancedSymbol;

part 'bucket/gallery.dart';
part 'bucket/glossary.dart';
part 'bucket/palette.dart';

abstract class Bucket<T> {
  Symbol get iD;

  FilledBucket<T> at(Symbol iD) => FilledBucket<T>.of(this.iD / iD);
}

class FilledBucket<T> {
  static final Map<Symbol, dynamic> _bucket = {};
  final Symbol targetID;

  FilledBucket.of(this.targetID);

  /// Get value
  T operator [](T defaultValue) {
    if (!_bucket.containsKey(targetID)) return defaultValue;
    return _bucket[targetID] ?? defaultValue;
  }

  /// Set value
  operator []=(T defaultValue, T? value) {
    if (_bucket.containsKey(targetID)) defaultValue = _bucket[targetID];
    _bucket[targetID] = value ?? defaultValue;
  }
}
