part of nueli.core.util;

extension AdvancedException on Exception {
  get msg => toString().replaceFirst('Exception: ', '');
}

extension AdvancedSymbol on Symbol {
  String get name => toString().substring(7, toString().length - 1);

  Symbol operator /(Symbol t) => Symbol(name + '.' + t.name);

  List<Symbol> get channel => name.split('.').map((e) => Symbol(e)).toList();

  Ref<T> ref<T>(T data) => Ref<T>.create(data);

  bool startsWith(Symbol path) => channel.startsWith(path.channel);

  bool endsWith(Symbol path) => channel.endsWith(path.channel);
}
